//---------------------------------------------------------------------------

#include <vcl.h>
#include <vcl\Clipbrd.hpp>
#pragma hdrstop

#include "ClipForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TClipForm1 *ClipForm1;

//---------------------------------------------------------------------------
// Language Functions:
//---------------------------------------------------------------------------

enum TextEnum {TE_Inactive, TE_Active, TE_Exit};
AnsiString English[] = {"Inactive", "Active", "Exit"};
AnsiString Danish[] = {"Inaktiv", "Aktiv", "Afslut"};

AnsiString LangText(TextEnum t)
{
	switch(PRIMARYLANGID(GetUserDefaultLCID()))
	{
	  case LANG_DANISH:  return Danish[t];
	  default:           return English[t];
	}
}

//---------------------------------------------------------------------------
// TClipForm1
//---------------------------------------------------------------------------
__fastcall TClipForm1::TClipForm1(TComponent* Owner)
		  : TForm(Owner)
{
 Hide();
 TrayIcon_Create ((AnsiString("HovText - ") + LangText(TE_Inactive)).c_str(),ImageInactive->Picture->Icon->Handle);
 Active1->Caption=LangText(TE_Active);
 Exit1->Caption=LangText(TE_Exit);
}

__fastcall TClipForm1::~TClipForm1()
{
 TrayIcon_Delete();
}


//---------------------------------------------------------------------------
// Clipboard Functions:
//---------------------------------------------------------------------------

void __fastcall TClipForm1::ConvertClip()
{
	try {
	  static char TextBuf[60000];
	  TClipboard *clip= Clipboard();

	  if (clip->HasFormat(CF_TEXT))
	  {
		  clip->GetTextBuf(TextBuf, sizeof TextBuf);
		  clip->SetTextBuf(TextBuf);
	  }
	} catch (...) {
	}
}


//---------------------------------------------------------------------------
// TrayIcon Functions:
//---------------------------------------------------------------------------

 void TClipForm1::TrayIcon_Create (const char *tipText,HICON hIcon)
  {

	 NOTIFYICONDATA info;
	 memset(&info,0,sizeof(info));
	 info.cbSize          =sizeof(info) ;
	 info.hWnd            =Handle;
	 info.uID             =WM_TRAY_ICON_ID;
	 info.uCallbackMessage=WM_TRAY_ICON_MESSAGE;
	 info.hIcon           =hIcon;
	 strncpy (info.szTip,tipText,sizeof(info.szTip));
	 info.szTip[sizeof(info.szTip)-1]='0';
	 info.uFlags          =NIF_MESSAGE | NIF_ICON | NIF_TIP ;
	 Shell_NotifyIcon(NIM_ADD,&info) ;
  }


//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyTip(const char *tipText)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.uFlags          =NIF_TIP;
  strncpy(info.szTip,tipText,sizeof(info.szTip));
  info.szTip[sizeof(info.szTip)-1]='\0';
  Shell_NotifyIcon(NIM_MODIFY,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_ModifyIcon(HICON hIcon)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize          =sizeof(info) ;
  info.hWnd            =Handle;
  info.uID             =WM_TRAY_ICON_ID;
  info.hIcon           =hIcon;
  info.uFlags          =NIF_ICON;
  Shell_NotifyIcon(NIM_MODIFY,&info) ;
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_Delete(void)
{
  NOTIFYICONDATA info;
  memset(&info,0,sizeof(info));
  info.cbSize=sizeof(info);
  info.hWnd  =Handle;
  info.uID   =WM_TRAY_ICON_ID;
  Shell_NotifyIcon(NIM_DELETE,&info);
}
//---------------------------------------------------------------------------
void TClipForm1::TrayIcon_HandleMessage(TMessage &Message)
{
  switch (Message.LParam)
  {
	 case WM_LBUTTONDBLCLK:
		break;
	 case WM_RBUTTONDOWN:
	 {
		POINT point;
		HWND Prev;
		::GetCursorPos(&point);
		SetForegroundWindow(Handle);

		PopupMenu1->Popup(point.x,point.y);
		Prev= GetForegroundWindow();
		SetForegroundWindow(Handle);
		SetForegroundWindow(Prev);
	 }
		break;
	 case WM_RBUTTONDBLCLK:
	 case WM_MOUSEMOVE:
	 case WM_LBUTTONDOWN:
		break;
  }
}
//---------------------------------------------------------------------------
// Menu Functions:
//---------------------------------------------------------------------------

void __fastcall TClipForm1::Exit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TClipForm1::Active1Click(TObject *Sender)
{
	Active1->Checked=!Active1->Checked;
	if (Active1->Checked) {
		TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Active)).c_str());
		TrayIcon_ModifyIcon(ImageActive->Picture->Icon->Handle);
	} else {
		TrayIcon_ModifyTip((AnsiString("HovText - ") + LangText(TE_Active)).c_str());
		TrayIcon_ModifyIcon(ImageInactive->Picture->Icon->Handle);
	}
}


//---------------------------------------------------------------------------
// Timer:
//---------------------------------------------------------------------------
void __fastcall TClipForm1::Timer1Timer(TObject *Sender)
{
	if (Active1->Checked)
		ConvertClip();
}
//---------------------------------------------------------------------------


